/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.lib;

import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author shuu
 */
public class SQLiteAdapter {

    protected static final String DB_TYPE = "jdbc:sqlite:";
    protected static final String DB_DRIVER = "org.sqlite.JDBC";
    protected static final String DB_SLINKPASS = ".slinkpass.sqlite";

    protected static final String TBL_PREFERENCE = "preference_tbl";
    protected static final String TBL_WEBCLIENT = "webclient_tbl";
    protected static final String TBL_RICHCLIENT = "richclient_tbl";
    protected static final String TBL_VPNCLIENT = "vpnclient_tbl";

    public static final String COL_PREFERENCE_ID = "id";
    public static final String COL_PREFERENCE_KEY = "key";
    public static final String COL_PREFERENCE_VAL = "val";

    public static final String COL_WEBCLIENT_ID = "id";
    public static final String COL_WEBCLIENT_NAME = "name";
    public static final String COL_WEBCLIENT_PATH = "path";
    public static final String COL_WEBCLIENT_PARAM = "param";

    public static final String COL_RICHCLIENT_ID = "id";
    public static final String COL_RICHCLIENT_NAME = "name";
    public static final String COL_RICHCLIENT_PATH = "path";
    public static final String COL_RICHCLIENT_PARAM = "param";

    public static final String COL_VPNCLIENT_ID = "id";
    public static final String COL_VPNCLIENT_NAME = "name";
    public static final String COL_VPNCLIENT_PATH = "path";
    public static final String COL_VPNCLIENT_PARAM = "param";

    public static final String COL_COMMON_CREATE_TIME = "create_time";
    public static final String COL_COMMON_UPDATE_TIME = "update_time";

    protected static final String CREATE_TBL_PREFERENCE =
            "create table " + TBL_PREFERENCE
            + " (" + COL_PREFERENCE_ID + " integer primary key autoincrement"
            + ", " + COL_PREFERENCE_KEY + " text not null unique"
            + ", " + COL_PREFERENCE_VAL + " text not null"
            + ", " + COL_COMMON_CREATE_TIME + " text not null"
            + ", " + COL_COMMON_UPDATE_TIME + " text not null"
            + ");";
    protected static final String CREATE_TBL_WEBCLIENT =
            "create table " + TBL_WEBCLIENT
            + " (" + COL_WEBCLIENT_ID + " integer primary key autoincrement"
            + ", " + COL_WEBCLIENT_NAME + " text not null"
            + ", " + COL_WEBCLIENT_PATH + " text not null"
            + ", " + COL_WEBCLIENT_PARAM + " text not null"
            + ", " + COL_COMMON_CREATE_TIME + " text not null"
            + ", " + COL_COMMON_UPDATE_TIME + " text not null"
            + ");";
    protected static final String CREATE_TBL_RICHCLIENT =
            "create table " + TBL_RICHCLIENT
            + " (" + COL_RICHCLIENT_ID + " integer primary key autoincrement"
            + ", " + COL_RICHCLIENT_NAME + " text not null"
            + ", " + COL_RICHCLIENT_PATH + " text not null"
            + ", " + COL_RICHCLIENT_PARAM + " text not null"
            + ", " + COL_COMMON_CREATE_TIME + " text not null"
            + ", " + COL_COMMON_UPDATE_TIME + " text not null"
            + ");";
    protected static final String CREATE_TBL_VPNCLIENT =
            "create table " + TBL_VPNCLIENT
            + " (" + COL_VPNCLIENT_ID + " integer primary key autoincrement"
            + ", " + COL_VPNCLIENT_NAME + " text not null"
            + ", " + COL_VPNCLIENT_PATH + " text not null"
            + ", " + COL_VPNCLIENT_PARAM + " text not null"
            + ", " + COL_COMMON_CREATE_TIME + " text not null"
            + ", " + COL_COMMON_UPDATE_TIME + " text not null"
            + ");";
    // 登録
    private static final String INSERT_TBL_PREFERENCE =
            "insert into " + TBL_PREFERENCE
            + " (" + COL_PREFERENCE_KEY + ", " + COL_PREFERENCE_VAL + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME + ")"
            + " values (?, ?, ?, ?)";
    private static final String INSERT_TBL_WEBCLIENT =
            "insert into " + TBL_WEBCLIENT
            + " (" + COL_WEBCLIENT_NAME + ", " + COL_WEBCLIENT_PATH + ", " + COL_WEBCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME + ")"
            + " values (?, ?, ?, ?, ?)";
    private static final String INSERT_TBL_RICHCLIENT =
            "insert into " + TBL_RICHCLIENT
            + " (" + COL_RICHCLIENT_NAME + ", " + COL_RICHCLIENT_PATH + ", " + COL_RICHCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME + ")"
            + " values (?, ?, ?, ?, ?)";
    private static final String INSERT_TBL_VPNCLIENT =
            "insert into " + TBL_VPNCLIENT
            + " (" + COL_VPNCLIENT_NAME + ", " + COL_VPNCLIENT_PATH + ", " + COL_VPNCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME + ")"
            + " values (?, ?, ?, ?, ?)";
    // 検索
    private static final String SELECT_TBL_PREFERENCE =
            "select " + COL_PREFERENCE_KEY + ", " + COL_PREFERENCE_VAL + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME
            + " from " + TBL_PREFERENCE;    // + " where " + COL_PREFERENCE_KEY + "=?";
    private static final String SELECT_TBL_WEBCLIENT =
            "select " + COL_WEBCLIENT_ID + ", " + COL_WEBCLIENT_NAME + ", " + COL_WEBCLIENT_PATH + ", " + COL_WEBCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME
            + " from " + TBL_WEBCLIENT;    // + " where " + COL_WEBCLIENT_ID + "=?";
    private static final String SELECT_TBL_RICHCLIENT =
            "select " + COL_RICHCLIENT_ID + ", " + COL_RICHCLIENT_NAME + ", " + COL_RICHCLIENT_PATH + ", " + COL_RICHCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME
            + " from " + TBL_RICHCLIENT;    // + " where " + COL_RICHCLIENT_ID + "=?";
    private static final String SELECT_TBL_VPNCLIENT =
            "select " + COL_VPNCLIENT_ID + ", " + COL_VPNCLIENT_NAME + ", " + COL_VPNCLIENT_PATH + ", " + COL_VPNCLIENT_PARAM + ", " + COL_COMMON_CREATE_TIME + ", " + COL_COMMON_UPDATE_TIME
            + " from " + TBL_VPNCLIENT;    // + " where " + COL_VPNCLIENT_ID + "=?";
    // 更新
    private static final String UPDATE_TBL_PREFERENCE =
            "update " + TBL_PREFERENCE + " set " + COL_PREFERENCE_VAL + "=?, " + COL_COMMON_UPDATE_TIME + "=?" 
            + " where " + COL_PREFERENCE_KEY + "=?";
    private static final String UPDATE_TBL_WEBCLIENT =
            "update " + TBL_WEBCLIENT
            + " set " + COL_WEBCLIENT_NAME  + "=?, " + COL_WEBCLIENT_PATH + "=?, " + COL_WEBCLIENT_PARAM + "=?, " + COL_COMMON_UPDATE_TIME + "=?" 
            + " where " + COL_WEBCLIENT_ID + "=?";
    private static final String UPDATE_TBL_RICHCLIENT =
            "update " + TBL_RICHCLIENT
            + " set " + COL_RICHCLIENT_NAME  + "=?, " + COL_RICHCLIENT_PATH + "=?, " + COL_RICHCLIENT_PARAM + "=?, " + COL_COMMON_UPDATE_TIME + "=?" 
            + " where " + COL_RICHCLIENT_ID + "=?";
    private static final String UPDATE_TBL_VPNCLIENT =
            "update " + TBL_VPNCLIENT
            + " set " + COL_VPNCLIENT_NAME  + "=?, " + COL_VPNCLIENT_PATH + "=?, " + COL_VPNCLIENT_PARAM + "=?, " + COL_COMMON_UPDATE_TIME + "=?" 
            + " where " + COL_VPNCLIENT_ID + "=?";
    // 削除
    private static final String DELETE_TBL_PREFERENCE =
            "delete from " + TBL_PREFERENCE + " where " + COL_PREFERENCE_KEY + "=?";
    private static final String DELETE_TBL_WEBCLIENT =
            "delete from " + TBL_WEBCLIENT + " where " + COL_WEBCLIENT_ID + "=?";
    private static final String DELETE_TBL_RICHCLIENT =
            "delete from " + TBL_RICHCLIENT + " where " + COL_RICHCLIENT_ID + "=?";
    private static final String DELETE_TBL_VPNCLIENT =
            "delete from " + TBL_VPNCLIENT + " where " + COL_VPNCLIENT_ID + "=?";
    
    private Connection mConnection;

    public SQLiteAdapter() {
        File f = new File(DB_SLINKPASS);
        boolean isNew = !f.exists();

        try {
            Class.forName(DB_DRIVER);
            mConnection = DriverManager.getConnection(DB_TYPE + DB_SLINKPASS);

            if (isNew) {
                Statement stmt = mConnection.createStatement();
                stmt.executeUpdate(CREATE_TBL_PREFERENCE);
                stmt.executeUpdate(CREATE_TBL_WEBCLIENT);
                stmt.executeUpdate(CREATE_TBL_RICHCLIENT);
                stmt.executeUpdate(CREATE_TBL_VPNCLIENT);
                stmt.close();
                SeciossUtils.setHidden(null, DB_SLINKPASS, true);
            }

        } catch (ClassNotFoundException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, null, ex);
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, null, ex);
        }
    }

    public void close() {
        try {
            mConnection.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, null, ex);
        }
    }

    public int insertPreference(String key, String val) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(INSERT_TBL_PREFERENCE);
            ps.setString(1, key);
            ps.setString(2, null == val ? "" : val);
            ps.setString(3, now);
            ps.setString(4, now);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, INSERT_TBL_PREFERENCE + " (" + key + "," + val + ")", ex);
        }
        return rs;
    }

    public int insertWebClient(String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(INSERT_TBL_WEBCLIENT);
            ps.setString(1, null == name ? "" : name);
            ps.setString(2, null == path ? "" : path);
            ps.setString(3, null == param ? "" : param);
            ps.setString(4, now);
            ps.setString(5, now);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, INSERT_TBL_WEBCLIENT + " (" + name + "," + path + "," + param + ")", ex);
        }
        return rs;
    }

    public int insertRichClient(String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(INSERT_TBL_RICHCLIENT);
            ps.setString(1, null == name ? "" : name);
            ps.setString(2, null == path ? "" : path);
            ps.setString(3, null == param ? "" : param);
            ps.setString(4, now);
            ps.setString(5, now);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, INSERT_TBL_RICHCLIENT + " (" + name + "," + path + "," + param + ")", ex);
        }
        return rs;
    }

    public int insertVpnClient(String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(INSERT_TBL_VPNCLIENT);
            ps.setString(1, null == name ? "" : name);
            ps.setString(2, null == path ? "" : path);
            ps.setString(3, null == param ? "" : param);
            ps.setString(4, now);
            ps.setString(5, now);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, INSERT_TBL_VPNCLIENT + " (" + name + "," + path + "," + param + ")", ex);
        }
        return rs;
    }

    public Map<String, String> selectPreference(String key) {
        Map<String, String> map = new HashMap<String, String>();
        String sql = SELECT_TBL_PREFERENCE;
        try {
            if (null != key) {
                sql += " where " + COL_PREFERENCE_KEY + "=?";
            }
            PreparedStatement ps = mConnection.prepareStatement(sql);
            if (null != key) {
                ps.setString(1, key);
            }
            ResultSet rs = ps.executeQuery();
            while (rs.next()) {
                map.put(rs.getString(COL_PREFERENCE_KEY), rs.getString(COL_PREFERENCE_VAL));
            }
            rs.close();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return map;
    }

    public List<Map<String, String>> selectWebClient(String id) {
        List<Map<String, String>> list = new ArrayList<Map<String, String>>();
        String sql = SELECT_TBL_WEBCLIENT;
        try {
            if (null != id) {
                sql += " where " + COL_WEBCLIENT_ID + "=?";
            }
            PreparedStatement ps = mConnection.prepareStatement(sql);
            if (null != id) {
                ps.setString(1, id);
            }
            ResultSet rs = ps.executeQuery();
            while (rs.next()) {
                Map<String, String> map = new HashMap<String, String>();
                map.put(COL_WEBCLIENT_ID, rs.getString(COL_WEBCLIENT_ID));
                map.put(COL_WEBCLIENT_NAME, rs.getString(COL_WEBCLIENT_NAME));
                map.put(COL_WEBCLIENT_PATH, rs.getString(COL_WEBCLIENT_PATH));
                map.put(COL_WEBCLIENT_PARAM, rs.getString(COL_WEBCLIENT_PARAM));
                map.put(COL_COMMON_CREATE_TIME, rs.getString(COL_COMMON_CREATE_TIME));
                map.put(COL_COMMON_UPDATE_TIME, rs.getString(COL_COMMON_UPDATE_TIME));
                list.add(map);
            }
            rs.close();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return list;
    }

    public List<Map<String, String>> selectRichClient(String id) {
        List<Map<String, String>> list = new ArrayList<Map<String, String>>();
        String sql = SELECT_TBL_RICHCLIENT;
        try {
            if (null != id) {
                sql += " where " + COL_RICHCLIENT_ID + "=?";
            }
            PreparedStatement ps = mConnection.prepareStatement(sql);
            if (null != id) {
                ps.setString(1, id);
            }
            ResultSet rs = ps.executeQuery();
            while (rs.next()) {
                Map<String, String> map = new HashMap<String, String>();
                map.put(COL_RICHCLIENT_ID, rs.getString(COL_RICHCLIENT_ID));
                map.put(COL_RICHCLIENT_NAME, rs.getString(COL_RICHCLIENT_NAME));
                map.put(COL_RICHCLIENT_PATH, rs.getString(COL_RICHCLIENT_PATH));
                map.put(COL_RICHCLIENT_PARAM, rs.getString(COL_RICHCLIENT_PARAM));
                map.put(COL_COMMON_CREATE_TIME, rs.getString(COL_COMMON_CREATE_TIME));
                map.put(COL_COMMON_UPDATE_TIME, rs.getString(COL_COMMON_UPDATE_TIME));
                list.add(map);
            }
            rs.close();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return list;
    }

    public List<Map<String, String>> selectVpnClient(String id) {
        List<Map<String, String>> list = new ArrayList<Map<String, String>>();
        String sql = SELECT_TBL_VPNCLIENT;
        try {
            if (null != id) {
                sql += " where " + COL_VPNCLIENT_ID + "=?";
            }
            PreparedStatement ps = mConnection.prepareStatement(sql);
            if (null != id) {
                ps.setString(1, id);
            }
            ResultSet rs = ps.executeQuery();
            while (rs.next()) {
                Map<String, String> map = new HashMap<String, String>();
                map.put(COL_RICHCLIENT_ID, rs.getString(COL_RICHCLIENT_ID));
                map.put(COL_RICHCLIENT_NAME, rs.getString(COL_RICHCLIENT_NAME));
                map.put(COL_RICHCLIENT_PATH, rs.getString(COL_RICHCLIENT_PATH));
                map.put(COL_RICHCLIENT_PARAM, rs.getString(COL_RICHCLIENT_PARAM));
                map.put(COL_COMMON_CREATE_TIME, rs.getString(COL_COMMON_CREATE_TIME));
                map.put(COL_COMMON_UPDATE_TIME, rs.getString(COL_COMMON_UPDATE_TIME));
                list.add(map);
            }
            rs.close();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return list;
    }

    public int updatePreference(String key, String val) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(UPDATE_TBL_PREFERENCE);
            ps.setString(1, val);
            ps.setString(2, now);
            ps.setString(3, key);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, UPDATE_TBL_PREFERENCE, ex);
        }
        return rs;
    }

    public int updateWebClient(String id, String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(UPDATE_TBL_WEBCLIENT);
            ps.setString(1, name);
            ps.setString(2, path);
            ps.setString(3, param);
            ps.setString(4, now);
            ps.setString(5, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, UPDATE_TBL_WEBCLIENT, ex);
        }
        return rs;
    }

    public int updateRichClient(String id, String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(UPDATE_TBL_RICHCLIENT);
            ps.setString(1, name);
            ps.setString(2, path);
            ps.setString(3, param);
            ps.setString(4, now);
            ps.setString(5, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, UPDATE_TBL_RICHCLIENT, ex);
        }
        return rs;
    }

    public int updateVpnClient(String id, String name, String path, String param) {
        int rs = 0;
        String now = String.valueOf(System.currentTimeMillis()/1000);
        try {
            PreparedStatement ps = mConnection.prepareStatement(UPDATE_TBL_VPNCLIENT);
            ps.setString(1, name);
            ps.setString(2, path);
            ps.setString(3, param);
            ps.setString(4, now);
            ps.setString(5, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, UPDATE_TBL_VPNCLIENT, ex);
        }
        return rs;
    }

    public int deletePreference(String key) {
        int rs = 0;
        if (null == key || "".equals(key)) {
            return rs;
        }
        String sql = DELETE_TBL_PREFERENCE;
        try {
            PreparedStatement ps = mConnection.prepareStatement(sql);
            ps.setString(1, key);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return rs;
    }

    public int deleteWebClient(String id) {
        int rs = 0;
        if (null == id || "".equals(id)) {
            return rs;
        }
        String sql = DELETE_TBL_WEBCLIENT;
        try {
            PreparedStatement ps = mConnection.prepareStatement(sql);
            ps.setString(1, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return rs;
    }

    public int deleteRichClient(String id) {
        int rs = 0;
        if (null == id || "".equals(id)) {
            return rs;
        }
        String sql = DELETE_TBL_RICHCLIENT;
        try {
            PreparedStatement ps = mConnection.prepareStatement(sql);
            ps.setString(1, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return rs;
    }

    public int deleteVpnClient(String id) {
        int rs = 0;
        if (null == id || "".equals(id)) {
            return rs;
        }
        String sql = DELETE_TBL_VPNCLIENT;
        try {
            PreparedStatement ps = mConnection.prepareStatement(sql);
            ps.setString(1, id);
            rs = ps.executeUpdate();
            ps.close();
        } catch (SQLException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, sql, ex);
        }
        return rs;
    }

}
