/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import java.awt.Toolkit;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.spass.components.SlinkPassFileFilter;

/**
 *
 * @author shuzx
 */
public class SlinkPassBrowser extends javax.swing.JFrame {

    private static final long serialVersionUID = 1L;

    public SlinkPassBrowser(SlinkPass parent) {
        this.mParent = parent;
        initComponents();
        onCreate();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mLabelBrowser = new javax.swing.JLabel();
        mTextBrowser = new javax.swing.JTextField();
        mButtonSave = new javax.swing.JButton();
        mButtonRefer = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("jp/co/secioss/res/Bundle"); // NOI18N
        setTitle(bundle.getString("SlinkPassBrowser.title")); // NOI18N
        setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/jp/co/secioss/res/SlinkPass48.png")));
        setMaximumSize(new java.awt.Dimension(360, 97));
        setMinimumSize(new java.awt.Dimension(360, 97));
        setName(""); // NOI18N
        setResizable(false);

        mLabelBrowser.setText(bundle.getString("SlinkPassBrowser.mLabelBrowser.text")); // NOI18N

        mButtonSave.setText(bundle.getString("SlinkPassBrowser.mButtonSave.text")); // NOI18N
        mButtonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mButtonSaveActionPerformed(evt);
            }
        });

        mButtonRefer.setText(bundle.getString("SlinkPassBrowser.mButtonRefer.text")); // NOI18N
        mButtonRefer.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mButtonReferActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(mLabelBrowser)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 135, Short.MAX_VALUE)
                        .addComponent(mButtonRefer))
                    .addComponent(mTextBrowser, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(mButtonSave)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(mLabelBrowser)
                    .addComponent(mButtonRefer))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mTextBrowser, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(mButtonSave)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void mButtonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mButtonSaveActionPerformed
        String resultInput = checkInput();
        if (null != resultInput) {
            JOptionPane.showOptionDialog(this, new JLabel(resultInput), mParent.getResourceBundle().getString("SlinkPass.dialog.title.warning"),
                    JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
            return;
        }

        if (null == mParent.getConfigure().get(SlinkPass.PREF_KEY_BROWSER)) {
            mSQLiteAdapter.insertPreference(SlinkPass.PREF_KEY_BROWSER, mTextBrowser.getText().trim());
        }
        else {
            mSQLiteAdapter.updatePreference(SlinkPass.PREF_KEY_BROWSER, mTextBrowser.getText().trim());
        }

        this.dispose();
    }//GEN-LAST:event_mButtonSaveActionPerformed

    private void mButtonReferActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mButtonReferActionPerformed
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogType(JFileChooser.CUSTOM_DIALOG);
        fileChooser.setFileFilter(new SlinkPassFileFilter(mParent.getResourceBundle().getString("SlinkPassBrowser.dialog.msg.filefilter")));
        int result = fileChooser.showDialog(this, mParent.getResourceBundle().getString("SlinkPassBrowser.dialog.button.select"));
        if (result == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            mTextBrowser.setText(file.getPath());
        }
    }//GEN-LAST:event_mButtonReferActionPerformed

    // "C:\Program Files (x86)\Mozilla Firefox\firefox.exe" -no-remote -P default
    private String checkInput() {
        String browser = mTextBrowser.getText().trim();
        if (!"".equals(browser)) {
            String fullpath;
            if (!browser.contains("\"")) {
                fullpath = browser;
            }
            else if (browser.indexOf("\"") == 0 && browser.lastIndexOf("\"") > 1) {
                fullpath = browser.substring(1);
                fullpath = fullpath.substring(0, fullpath.indexOf("\""));
            }
            else {
                return mParent.getResourceBundle().getString("SlinkPassBrowser.dialog.error.path");
            }

            File file = new File(fullpath);
            String os = System.getProperty("os.name");
            if (os.startsWith("Mac")) {
                if (!file.exists()) {
                    return mParent.getResourceBundle().getString("SlinkPassBrowser.dialog.error.path");
                }
            }
            else {
                if (!file.exists() || !file.isFile()) {
                    return mParent.getResourceBundle().getString("SlinkPassBrowser.dialog.error.path");
                }
            }
        }
        return null;
    }

    private void onCreate() {
        mSQLiteAdapter = mParent.getSQLiteAdapter();
        mTextBrowser.setText(mParent.getConfigure().get(SlinkPass.PREF_KEY_BROWSER));
    }

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton mButtonRefer;
    private javax.swing.JButton mButtonSave;
    private javax.swing.JLabel mLabelBrowser;
    private javax.swing.JTextField mTextBrowser;
    // End of variables declaration//GEN-END:variables

    public javax.swing.JLabel getLabelBrowser() {
        return mLabelBrowser;
    }

    public javax.swing.JButton getButtonSave() {
        return mButtonSave;
    }

    public javax.swing.JButton getButtonRefer() {
        return mButtonRefer;
    }

}
