/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.spass.components.SlinkPassFileFilter;

/**
 *
 * @author shuu
 */
public class SlinkPassEditorRc extends SlinkPassEditorAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String mId;

    public SlinkPassEditorRc(SlinkPass parent, String[] data) {
        super(parent, data[1], data[2], data[3]);

        this.mParent = parent;
        this.mSQLiteAdapter = mParent.getSQLiteAdapter();
        this.mId = data[0];

        getLabelScheme().setVisible(false);

        setTitle(mParent.getResourceBundle().getString("SlinkPassEditorRc.title"));
        getLabelName().setText(mParent.getResourceBundle().getString("SlinkPassEditorRc.mLabelName.text"));
        getLabelPath().setText(mParent.getResourceBundle().getString("SlinkPassEditorRc.mLabelPath.text"));
        getLabelParam().setText(mParent.getResourceBundle().getString("SlinkPassEditorRc.mLabelParam.text"));
        getButtonRefer().setText(mParent.getResourceBundle().getString("SlinkPassEditorRc.mButtonRefer.text"));
        getButtonSave().setText(mParent.getResourceBundle().getString("SlinkPassEditorRc.mButtonSave.text"));
    }

    @Override
    public void buttonReferActionPerformed(ActionEvent evt) {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogType(JFileChooser.CUSTOM_DIALOG);
        fileChooser.setFileFilter(new SlinkPassFileFilter(mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.msg.filefilter")));
        int result = fileChooser.showDialog(this, mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.button.select"));
        if (result == JFileChooser.APPROVE_OPTION) {
            File file = fileChooser.getSelectedFile();
            getTextPath().setText(file.getPath());
        }
    }

    @Override
    public void buttonSaveActionPerformed(ActionEvent evt) {
        String result = checkInput();
        if (null != result) {
            JOptionPane.showOptionDialog(this, new JLabel(result), mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                    JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
            return;
        }

        if (null == mId) {
            mSQLiteAdapter.insertRichClient(getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        else {
            mSQLiteAdapter.updateRichClient(mId, getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        this.dispose();
    }

    private String checkInput() {
        if ("".equals(getTextName().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.error.noname");
        }
        if ("".equals(getTextPath().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.error.nopath");
        }

        if ("".equals(getTextParam().getText().trim())) {
            File file = new File(getTextPath().getText().trim());
            String os = System.getProperty("os.name");
            if (os.startsWith("Mac")) {
                if (!file.exists()) {
                    return mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.error.path");
                }
            }
            else {
                if (!file.exists() || !file.isFile()) {
                    return mParent.getResourceBundle().getString("SlinkPassEditorRc.dialog.error.path");
                }
            }
        }

        return null;
    }

}
