/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import jp.co.secioss.lib.SQLiteAdapter;

/**
 *
 * @author shuu
 */
public class SlinkPassEditorVpn extends SlinkPassEditorAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String mId;

    public SlinkPassEditorVpn(SlinkPass parent, String[] data) {
        super(parent, data[1], data[2], data[3]);

        this.mParent = parent;
        this.mSQLiteAdapter = mParent.getSQLiteAdapter();
        this.mId = data[0];

        getLabelScheme().setVisible(false);
        getButtonRefer().setVisible(false);

        setTitle(mParent.getResourceBundle().getString("SlinkPassEditorVpn.title"));
        getLabelName().setText(mParent.getResourceBundle().getString("SlinkPassEditorVpn.mLabelName.text"));
        getLabelPath().setText(mParent.getResourceBundle().getString("SlinkPassEditorVpn.mLabelPath.text"));
        getButtonSave().setText(mParent.getResourceBundle().getString("SlinkPassEditorVpn.mButtonSave.text"));

        getLabelParam().setText(mParent.getResourceBundle().getString("SlinkPassEditorVpn.mLabelParam.text"));
        getTextParam().setEditable(false);
        String os = System.getProperty("os.name");
        if (os.startsWith("Windows")) {
            getTextParam().setText("rasdial profile %{id} %{pw}");
        }
        else if (os.startsWith("Mac")) {
            getTextParam().setText("scutil --nc start profile --user %{id} --password %{pw}");
        }
        else {
            getLabelParam().setVisible(false);
            getTextParam().setVisible(false);
        }
    }

    @Override
    public void buttonReferActionPerformed(ActionEvent evt) {}

    @Override
    public void buttonSaveActionPerformed(ActionEvent evt) {
        String result = checkInput();
        if (null != result) {
            JOptionPane.showOptionDialog(this, new JLabel(result), mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                    JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
            return;
        }

        if (null == mId) {
            mSQLiteAdapter.insertVpnClient(getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        else {
            mSQLiteAdapter.updateVpnClient(mId, getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        this.dispose();
    }

    private String checkInput() {
        if ("".equals(getTextName().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorVpn.dialog.error.noname");
        }
        if ("".equals(getTextPath().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorVpn.dialog.error.nopath");
        }
        return null;
    }

}
