/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import jp.co.secioss.lib.SeciossUtils;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.lib.SeciossCommon;

/**
 *
 * @author shuu
 */
public class SlinkPassEditorWc extends SlinkPassEditorAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String mId;

    public SlinkPassEditorWc(SlinkPass parent, String[] data) {
        super(parent, data[1], data[2], data[3]);

        this.mParent = parent;
        this.mSQLiteAdapter = mParent.getSQLiteAdapter();
        this.mId = data[0];

        getLabelParam().setVisible(false);
        getTextParam().setVisible(false);
        getButtonRefer().setVisible(false);

        setTitle(mParent.getResourceBundle().getString("SlinkPassEditorWc.title"));
        getLabelName().setText(mParent.getResourceBundle().getString("SlinkPassEditorWc.mLabelName.text"));
        getLabelPath().setText(mParent.getResourceBundle().getString("SlinkPassEditorWc.mLabelPath.text"));
        getLabelScheme().setText(mParent.getResourceBundle().getString("SlinkPassAccount.mLabelScheme.text"));
        getButtonSave().setText(mParent.getResourceBundle().getString("SlinkPassEditorWc.mButtonSave.text"));
    }

    @Override
    public void buttonReferActionPerformed(ActionEvent evt) {}

    @Override
    public void buttonSaveActionPerformed(ActionEvent evt) {
        String result = checkInput();
        if (null != result) {
            JOptionPane.showOptionDialog(this, new JLabel(result), mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                    JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
            return;
        }

        if (null == mId) {
            mSQLiteAdapter.insertWebClient(getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        else {
            mSQLiteAdapter.updateWebClient(mId, getTextName().getText().trim(), getTextPath().getText().trim(), getTextParam().getText().trim());
        }
        this.dispose();
    }

    private String checkInput() {
        if ("".equals(getTextName().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorWc.dialog.error.noname");
        }
        if ("".equals(getTextPath().getText().trim())) {
            return mParent.getResourceBundle().getString("SlinkPassEditorWc.dialog.error.nopath");
        }
        if (SeciossCommon.checkUrl(SeciossUtils.URI_SCHEME + getTextPath().getText().trim()) != 0) {
            return mParent.getResourceBundle().getString("SlinkPassEditorWc.dialog.error.path");
        }
        return null;
    }

}
