/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import jp.co.secioss.lib.SeciossUtils;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CancellationException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingWorker;
import javax.swing.UIManager;
import javax.swing.table.TableModel;
import jp.co.secioss.lib.MD5;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.lib.SeciossCommon;
import jp.co.secioss.spass.components.SlinkPassTableCellEditorAndRenderer;
import jp.co.secioss.spass.components.SlinkPassTableModel;
//import org.xmlpull.v1.XmlPullParser;
//import org.xmlpull.v1.XmlPullParserException;
//import org.xmlpull.v1.XmlPullParserFactory;

/**
 *
 * @author shuu
 */
public class SlinkTabPanelRc extends SlinkTabPanelAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String[] mProxy;
    private String mSecret;
    private String mIPAddr;
    private String mAppxml;
    private String mSessid;

    public SlinkTabPanelRc(SlinkPass parent) {
        super();
        this.mParent = parent;
        mSQLiteAdapter = parent.getSQLiteAdapter();

        mSecret = mParent.getConfigure().get(SlinkPass.PREF_KEY_DECODED);
        mIPAddr = SeciossCommon.getLocalIpAddress();
        initTable();
        initNetwork();
        initAppxmlAsync();
    }

    private void initTable() {
        List<Map<String, String>> list = mSQLiteAdapter.selectRichClient(null);
        int count = list.size();
        String rows[][] = new String[1][6];
        if (count > 0) {
            rows = new String[count + 1][6];
            for (int i = 0; i < count; i++) {
                Map<String, String> map = list.get(i);
                rows[i][0] = map.get(SQLiteAdapter.COL_RICHCLIENT_ID);
                rows[i][1] = map.get(SQLiteAdapter.COL_RICHCLIENT_NAME);
                rows[i][2] = map.get(SQLiteAdapter.COL_RICHCLIENT_PATH);
                rows[i][3] = map.get(SQLiteAdapter.COL_RICHCLIENT_PARAM);
                rows[i][4] = map.get(SQLiteAdapter.COL_COMMON_CREATE_TIME);
                rows[i][5] = map.get(SQLiteAdapter.COL_COMMON_UPDATE_TIME);
            }
        }

        String[] cols = new String[] {
                //SQLiteAdapter.COL_RICHCLIENT_ID,
                SQLiteAdapter.COL_RICHCLIENT_NAME,
                //SQLiteAdapter.COL_RICHCLIENT_PATH,
                //SQLiteAdapter.COL_RICHCLIENT_PARAM,
                //SQLiteAdapter.COL_COMMON_CREATE_TIME,
                //SQLiteAdapter.COL_COMMON_UPDATE_TIME,
                COL_TABLE_OPERATION
        };

        Class<?>[] typs = new Class<?>[] {String.class, JPanel.class};

        TableModel model = new SlinkPassTableModel(rows, cols, typs, (null != mSecret && !"".equals(mSecret)));
        getJTable1().setModel(model);
        getJTable1().getColumnModel().getColumn(cols.length-1).setPreferredWidth(0);

        getJTable1().getColumn(SQLiteAdapter.COL_RICHCLIENT_NAME).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(SQLiteAdapter.COL_RICHCLIENT_NAME).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
    }

    private void initNetwork() {
        String proxytpye = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_TYPE);
        String proxyhost = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_HOST);
        String proxyport = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PORT);
        String proxyuser = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_USER);
        String proxypass = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PASS);
        mProxy = new String[] {proxytpye, proxyhost, proxyport, proxyuser, proxypass};
    }

    private void initAppxmlAsync() {
        if (null == mSecret || "".equals(mSecret)) {
            return;
        }
        mAppxml = "";
        String server = SeciossUtils.URI_SCHEME + mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER) + SeciossUtils.URI_PATH_APPXML;
        String params = "";
        new SlinkSwingWorker(server, params, mProxy) {
            @Override
            public void done() {
                try {
                    mAppxml = get(TIMEOUT, TimeUnit.SECONDS);
                    if (!"".equals(mAppxml)) {
                        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINE, "DEBUG - Fetch appxml succeeded");
                    }
                    else {
                        mParent.getLabelErrors().setText(mParent.getResourceBundle().getString("SlinkPass.mLabelErrors.appxml"));
                    }
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch appxml failed", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch appxml failed", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch appxml failed", ex);
                }
            }
        }.execute();
    }

    @Override
    public void doEdit(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }

        final SlinkPassEditorRc slinkPassEditorRc = new SlinkPassEditorRc(mParent, data);
        SeciossUtils.center(mParent, slinkPassEditorRc);
        slinkPassEditorRc.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosed(WindowEvent e) {
                initTable();
            }
        });
        slinkPassEditorRc.setVisible(true);
    }

    @Override
    public void doDele(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }
        int i = JOptionPane.showOptionDialog(this, new JLabel(mParent.getResourceBundle().getString("SlinkTabPanelRc.dialog.confirm")), mParent.getResourceBundle().getString("SlinkPass.dialog.title.confirm"),
                        JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, UIManager.getIcon("OptionPane.questionIcon"), mParent.getButtonsConfirmDialog(), mParent.getButtonsConfirmDialog()[1]);
        if (i==0) {
            mSQLiteAdapter.deleteRichClient(data[0]);
            initTable();
        }
    }

    @Override
    public void doOpen(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }

        registerApplicationAsync(data[2], data[3]);
    }

    private String parseSsoid(String filename) {
        if (null == filename || "".equals(filename)) {
            return null;
        }

        String ssoid = "";
        String filenameWithoutExtension = filename;
        if (filename.lastIndexOf(".") > 0) {
            filenameWithoutExtension = filename.substring(0, filename.lastIndexOf("."));    // Execution file without suffix(.exe)
        }
        String os = System.getProperty("os.name");
        if (os.startsWith("Windows")) {
            ssoid = filenameWithoutExtension;
        }
        else {
//            try {
//                XmlPullParser xpp = XmlPullParserFactory.newInstance().newPullParser();
//                xpp.setInput(new StringReader(mAppxml));
//                while (xpp.getEventType() != XmlPullParser.END_DOCUMENT) {
//                    if (xpp.getEventType() == XmlPullParser.START_TAG) {
//                        if (xpp.getName().equalsIgnoreCase("app")) {
//                            xpp.next();xpp.next();
//                            if (xpp.getName().equalsIgnoreCase("ssoid")) {
//                                xpp.next();
//                                ssoid = xpp.getText();
//                            }
//                            xpp.next();xpp.next();xpp.next();
//                            if (xpp.getName().equalsIgnoreCase("macos")) {
//                                xpp.next();
//                                if (filenameWithoutExtension.equalsIgnoreCase(xpp.getText())) {
//                                    break;
//                                }
//                            }
//                        }
//                    }
//                    ssoid = "";
//                    xpp.next();
//                }
//            } catch (XmlPullParserException e) {
//                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Internal server error");
//            } catch (IOException e) {
//                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Internal server error");
//            }
        }
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINE, "DEBUG - Parse ssoid succeeded - name:{0} ssoid:{1}", new String[] {filenameWithoutExtension, ssoid});
        return ssoid;
    }

    private String prepareUriParams(String path) {
        String params = "";
        String pinnum = mParent.getConfigure().get(SlinkPass.PREF_KEY_PINNUM);
        String device = mParent.getConfigure().get(SlinkPass.PREF_KEY_DEVICE);
        String userid = mParent.getConfigure().get(SlinkPass.PREF_KEY_USERID);
        String tenant = userid.substring(userid.indexOf("@") + 1);

        String username = new MD5(device).asHex() + "#" + userid;
        String password = SeciossCommon.generateOTP(mSecret, pinnum);
        String version = mParent.getConfigure().get(SlinkPass.PREF_KEY_VERSION);
        String os = System.getProperty("os.name");

        String filename = SeciossUtils.parseFilename(path);
        String ssoid = parseSsoid(filename);
        try {
            params = "username=" + URLEncoder.encode(username, "UTF-8")
                   + "&password=" + URLEncoder.encode(password, "UTF-8")
                   + "&tenant=" + URLEncoder.encode(tenant, "UTF-8")
                   + "&app=" + URLEncoder.encode(ssoid, "UTF-8")
                   + "&ia=" + URLEncoder.encode(new MD5(mIPAddr).asHex(), "UTF-8")
                   + "&version=" + version
                   + "&os=" + URLEncoder.encode(os, "UTF-8");
        }
        catch (UnsupportedEncodingException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "UnsupportedEncodingException", ex);
            onRegisterApplicationResult(null, null, null);
        }
        return params;
    }

    private void registerApplicationAsync(final String path, final String param) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINER, "DEBUG - registerApplicationAsync start");
        String server = SeciossUtils.URI_SCHEME + mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER) + SeciossUtils.URI_PATH_IPAUTH;
        String params = prepareUriParams(path);
        if ("".equals(params)) {
            return;
        }

        JOptionPane optionPane = new JOptionPane(mParent.getResourceBundle().getString("SlinkPassAccount.dialog.cancel"), 
                JOptionPane.CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE, new ImageIcon(getClass().getResource("/jp/co/secioss/res/loading.gif")),
                mParent.getButtonsCancelDialog());
        final JDialog dialog = optionPane.createDialog(mParent, mParent.getResourceBundle().getString("SlinkPass.dialog.title.result"));
        SlinkSwingWorker slinkSwingWorker = new SlinkSwingWorker(server, params, mProxy) {
            @Override
            public void done() {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - registerApplicationAsync finish");
                dialog.dispose();
                String result = null;
                try {
                    result = get(TIMEOUT, TimeUnit.SECONDS);
                } catch (CancellationException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - Launch application canceled");
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Launch application failed", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Launch application failed", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Launch application failed", ex);
                }
                onRegisterApplicationResult(result, path, param);
            }
        };
        slinkSwingWorker.execute();
        dialog.setVisible(true);
        if (null != optionPane.getValue() && mParent.getButtonsCancelDialog()[0].equals(optionPane.getValue())) {
            slinkSwingWorker.cancel(true);
        }
    }

    private void onRegisterApplicationResult(String response, String path, String param) {
        if (null == response) {
            return;
        }
        String message;
        if (!"".equals(response)) {
            int sIndex = response.indexOf("<code>");
            int eIndex = response.indexOf("</code>");
            String code = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 6, eIndex) : "";
            if ("0".equals(code)) {
                sIndex = response.indexOf("<sessid>");
                eIndex = response.indexOf("</sessid>");
                mSessid = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 8, eIndex) : "";
                if (!"".equals(mSessid)) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Register application succeeded");
                    try {
                        SeciossUtils.launchApplication(path, param, path.contains("/") || path.contains("\\"));
                        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Launch Application succeeded: {0} {1}", new String[] {path, param});
                        startApplicationTimerAsync(path);
                        return;
                    } catch (IOException ex) {
                        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Launch Application failed", ex);
                        message = "Launch Application failed: " + ex.getMessage();
                    }
                }
                else {
                    message = "Server error: Invalid session";
                }
            }
            else {
                if (response.endsWith("Exception")) {
                    code = "97";
                }
                else {
                    code = response;
                }
                if (Arrays.asList(SeciossUtils.ERROR_CODES).contains(code)) {
                    message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error." + code);
                }
                else {
                    message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error.");
                }
            }
        }
        else {
            message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error.");
        }
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, message);
        JOptionPane.showOptionDialog(this, message, mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
    }

    private void startApplicationTimerAsync(final String path) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "startApplicationTimerAsync start");
        final String filename = SeciossUtils.parseFilename(path);
        final String ssoid = parseSsoid(filename);
        new SwingWorker<Integer, Integer>() {
            int timemin;
            @Override
            @SuppressWarnings("SleepWhileInLoop")
            protected Integer doInBackground() {
                try {
                    timemin = Integer.parseInt(SeciossUtils.readProperties(SeciossUtils.PROPERTY_RCSTATUS_TIMEMIN, SeciossUtils.DEFAULT_RCSTATUS_TIMEMIN, SeciossUtils.getSecretPropertiesFilename()));
                } catch (NumberFormatException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, "Invalid " + SeciossUtils.PROPERTY_RCSTATUS_TIMEMIN, ex);
                    timemin = 10;
                }
                try {
                    for (int i = 0; i < timemin; i++) {
                        publish(i);
                        //Thread.sleep(60*1000);
                        Thread.sleep(1);
                    }
                    return timemin;
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "", ex);
                }
                return 0;
            }

            @Override
            public void process(List<Integer> chunks) {
                for (int i : chunks) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Time to check {0} status: {1} minute(s)", new Object[]{ssoid, timemin - i});
                }
            }

            @Override
            public void done() {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "startApplicationTimerAsync finish");
                onApplicationTimerResult(filename, ssoid);
            }
        }.execute();
    }

    private void onApplicationTimerResult(String filename, String ssoid) {
        getApplicationStatusAsync(filename, ssoid);
    }

    /**
     * Check if the given application is alive in the system task list
     * @param filename
     * @return 0 if alive 1 otherwise
     */
    private void getApplicationStatusAsync(final String filename, final String ssoid) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "getApplicationStatusAsync start");
        new SwingWorker<Integer, Void>() {
            String os = System.getProperty("os.name");
            @Override
            protected Integer doInBackground() {
                BufferedReader bufferedReader = null;
                Process process = null;
                try {
                    if (os.startsWith("Windows")) {
                        process = Runtime.getRuntime().exec("tasklist /fo csv");
                    }
                    else {
                        process = Runtime.getRuntime().exec("ps -ef");
                    }

                    bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream(), System.getProperty("sun.jnu.encoding")));
                    String line = bufferedReader.readLine();
                    while (line != null) {
                        if (line.toLowerCase().contains(filename)) {
                            try {
                                bufferedReader.close();
                            } catch (IOException ex) {
                                 Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Close bufferedReader failed", ex);
                            }
                            process.destroy();
                            return 0;
                        }
                        line = bufferedReader.readLine();
                    }
                    process.waitFor();    // HAVE TO BE PUT ON LAST STATEMENT

                } catch (IOException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Get process list failed", ex);
                } catch (InterruptedException ex) {
                //    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Get process list failed", ex);
                } finally {
                    if (null != bufferedReader) {
                        try {
                            bufferedReader.close();
                        } catch (IOException ex) {
                             Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Close bufferedReader failed", ex);
                        }
                    }
                    if (null != process) {
                        process.destroy();
                    }
                }

                return 1;
            }

            @Override
            public void done() {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "getApplicationStatusAsync finish");
                int status = 1;
                try {
                    status = get(SlinkSwingWorker.TIMEOUT, TimeUnit.SECONDS);
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Application {0} is " + (status == 0 ? "" : "not ") + "alive", filename);
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Get process list failed", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Get process list failed", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Get process list failed", ex);
                }
                onApplicationStatusResult(ssoid, status);
            }
        }.execute();
    }

    private void onApplicationStatusResult(String ssoid, int status) {
        registerApplicationStatusAsync(ssoid, status);
    }

    private void registerApplicationStatusAsync(String ssoid, int status) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - registerApplicationStatusAsync start");
        String server = SeciossUtils.URI_SCHEME + mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER) + SeciossUtils.URI_PATH_IPAUTH + "?action=result";
        String params = "sessid=" + mSessid + "&app=" + ssoid + "&code=" + status;

        new SlinkSwingWorker(server, params, mProxy) {
            @Override
            public void done() {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - registerApplicationStatusAsync finish");
                String result = null;
                try {
                    result = get(TIMEOUT, TimeUnit.SECONDS);
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "", ex);
                }
                onRegisterApplicationStatusResult(result);
            }
        }.execute();
    }

    private void onRegisterApplicationStatusResult(String response) {
        if (null == response) {
            return;
        }
        String message;
        if (!"".equals(response)) {
            int sIndex = response.indexOf("<code>");
            int eIndex = response.indexOf("</code>");
            String code = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 6, eIndex) : "";
            if ("0".equals(code)) {
                message = "Register application status succeeded";
            }
            else {
                message = "Register application status failed";
            }
        }
        else {
            message = "Register application status failed";
        }
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, message);
//        JOptionPane.showOptionDialog(this, new JLabel(message), mParent.getResourceBundle().getString("SlinkPass.dialog.title.result"),
//                JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE, UIManager.getIcon("OptionPane.informationIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
    }

}
