/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import jp.co.secioss.lib.SeciossUtils;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CancellationException;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingWorker;
import javax.swing.UIManager;
import javax.swing.table.TableModel;
import jp.co.secioss.lib.MD5;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.lib.SeciossCommon;
import jp.co.secioss.spass.components.SlinkPassTableCellEditorAndRenderer;
import jp.co.secioss.spass.components.SlinkPassTableModel;

/**
 *
 * @author shuu
 */
public class SlinkTabPanelVpn extends SlinkTabPanelAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String[] mProxy;
    private String mSecret;

    public SlinkTabPanelVpn(SlinkPass parent) {
        super();
        this.mParent = parent;
        mSQLiteAdapter = parent.getSQLiteAdapter();

        mSecret = mParent.getConfigure().get(SlinkPass.PREF_KEY_DECODED);
        initTable();
        initNetwork();
    }

    private void initTable() {
        List<Map<String, String>> list = mSQLiteAdapter.selectVpnClient(null);
        int count = list.size();
        String rows[][] = new String[1][6];
        if (count > 0) {
            rows = new String[count + 1][6];
            for (int i = 0; i < count; i++) {
                Map<String, String> map = list.get(i);
                rows[i][0] = map.get(SQLiteAdapter.COL_VPNCLIENT_ID);
                rows[i][1] = map.get(SQLiteAdapter.COL_VPNCLIENT_NAME);
                rows[i][2] = map.get(SQLiteAdapter.COL_VPNCLIENT_PATH);
                rows[i][3] = map.get(SQLiteAdapter.COL_VPNCLIENT_PARAM);
                rows[i][4] = map.get(SQLiteAdapter.COL_COMMON_CREATE_TIME);
                rows[i][5] = map.get(SQLiteAdapter.COL_COMMON_UPDATE_TIME);
            }
        }

        String[] cols = new String[] {
                //SQLiteAdapter.COL_VPNCLIENT_ID,
                SQLiteAdapter.COL_VPNCLIENT_NAME,
                //SQLiteAdapter.COL_VPNCLIENT_PATH,
                //SQLiteAdapter.COL_VPNCLIENT_PARAM,
                //SQLiteAdapter.COL_COMMON_CREATE_TIME,
                //SQLiteAdapter.COL_COMMON_UPDATE_TIME,
                COL_TABLE_OPERATION
        };

        Class<?>[] typs = new Class<?>[] {String.class, JPanel.class};

        TableModel model = new SlinkPassTableModel(rows, cols, typs, (null != mSecret && !"".equals(mSecret)));
        getJTable1().setModel(model);
        getJTable1().getColumnModel().getColumn(cols.length-1).setPreferredWidth(0);

        getJTable1().getColumn(SQLiteAdapter.COL_VPNCLIENT_NAME).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(SQLiteAdapter.COL_VPNCLIENT_NAME).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
    }

    private void initNetwork() {
        String proxytpye = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_TYPE);
        String proxyhost = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_HOST);
        String proxyport = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PORT);
        String proxyuser = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_USER);
        String proxypass = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PASS);
        mProxy = new String[] {proxytpye, proxyhost, proxyport, proxyuser, proxypass};
    }

    @Override
    public void doEdit(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }

        final SlinkPassEditorVpn slinkPassEditorVpn = new SlinkPassEditorVpn(mParent, data);
        SeciossUtils.center(mParent, slinkPassEditorVpn);
        slinkPassEditorVpn.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosed(WindowEvent e) {
                initTable();
            }
        });
        slinkPassEditorVpn.setVisible(true);
    }

    @Override
    public void doDele(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }
        int i = JOptionPane.showOptionDialog(this, new JLabel(mParent.getResourceBundle().getString("SlinkTabPanelVpn.dialog.confirm")), mParent.getResourceBundle().getString("SlinkPass.dialog.title.confirm"),
                        JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, UIManager.getIcon("OptionPane.questionIcon"), mParent.getButtonsConfirmDialog(), mParent.getButtonsConfirmDialog()[1]);
        if (i==0) {
            mSQLiteAdapter.deleteVpnClient(data[0]);
            initTable();
        }
    }

    @Override
    public void doOpen(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }

        fetchCredentialAsync(data[2], data[3]);
    }

    private void fetchCredentialAsync(final String path, final String param) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINE, "DEBUG - fetchCredentialAsync start");
        String server = SeciossUtils.URI_SCHEME + mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER) + SeciossUtils.URI_PATH_CREDIT;
        String params;

        String pinnum = mParent.getConfigure().get(SlinkPass.PREF_KEY_PINNUM);
        String device = mParent.getConfigure().get(SlinkPass.PREF_KEY_DEVICE);
        String userid = mParent.getConfigure().get(SlinkPass.PREF_KEY_USERID);
        String tenant = userid.substring(userid.indexOf("@") + 1);

        String username = new MD5(device).asHex() + "#" + userid;
        String password = SeciossCommon.generateOTP(mSecret, pinnum);
        String version = mParent.getConfigure().get(SlinkPass.PREF_KEY_VERSION);
        String os = System.getProperty("os.name");

        try {
            params = "username=" + URLEncoder.encode(username, "UTF-8")
                   + "&password=" + URLEncoder.encode(password, "UTF-8")
                   + "&tenant=" + URLEncoder.encode(tenant, "UTF-8")
                   + "&version=" + version
                   + "&os=" + URLEncoder.encode(os, "UTF-8");
        }
        catch (UnsupportedEncodingException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "UnsupportedEncodingException", ex);
            onFetchCredentialResult(null, null, null);
            return;
        }

        JOptionPane optionPane = new JOptionPane(mParent.getResourceBundle().getString("SlinkPassAccount.dialog.cancel"), 
                JOptionPane.CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE, new ImageIcon(getClass().getResource("/jp/co/secioss/res/loading.gif")),
                mParent.getButtonsCancelDialog());
        final JDialog dialog = optionPane.createDialog(mParent, mParent.getResourceBundle().getString("SlinkPass.dialog.title.result"));
        SlinkSwingWorker slinkSwingWorker = new SlinkSwingWorker(server, params, mProxy) {
            @Override
            public void done() {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - fetchCredentialAsync finish");
                dialog.dispose();
                String result = null;
                try {
                    result = get(TIMEOUT, TimeUnit.SECONDS);
                } catch (CancellationException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - Fetch credential canceled");
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Fetch credential failed", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Fetch credential failed", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Fetch credential failed", ex);
                }
                onFetchCredentialResult(result, path, param);
            }
        };
        slinkSwingWorker.execute();
        dialog.setVisible(true);
        
        if (null != optionPane.getValue() && mParent.getButtonsCancelDialog()[0].equals(optionPane.getValue())) {
            slinkSwingWorker.cancel(true);
        }
    }

    private void onFetchCredentialResult(String response, String path, String param) {
        if (null == response) {
            return;
        }
        String message;
        if (!"".equals(response)) {
            int sIndex = response.indexOf("<code>");
            int eIndex = response.indexOf("</code>");
            String code = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 6, eIndex) : "";
            if ("0".equals(code)) {
                Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Fetch Credential succeeded");
                // ID取得
                sIndex = response.indexOf("<id>");
                eIndex = response.indexOf("</id>");
                String id = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 4, eIndex) : "";
                if ("".equals(id)) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.CONFIG, "DEBUG - no id");
                }
                // PW取得
                sIndex = response.indexOf("<password>");
                eIndex = response.indexOf("</password>");
                String pw = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex + 10, eIndex) : "";
                if ("".equals(pw)) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.CONFIG, "DEBUG - no password");
                }

                connectVpnAsync(path, param, id, pw);
                return;
            }
            else {
                if (response.endsWith("Exception")) {
                    code = "97";
                }
                else {
                    code = response;
                }
                if (Arrays.asList(SeciossUtils.ERROR_CODES).contains(code)) {
                    message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error." + code);
                }
                else {
                    message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error.");
                }
            }
        }
        else {
            message = mParent.getResourceBundle().getString("SlinkPassAccount.dialog.error.");
        }
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, message);
        JOptionPane.showOptionDialog(this, message, mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
    }

    private void connectVpnAsync(String path, String param, String id, String pw) {
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINE, "DEBUG - connectVpnAsync start");

        final JOptionPane optionPane = new JOptionPane(mParent.getResourceBundle().getString("SlinkTabPanelVpn.dialog.connect"), 
                JOptionPane.CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE, new ImageIcon(getClass().getResource("/jp/co/secioss/res/loading.gif")),
                mParent.getButtonsCancelDialog());
        final JDialog dialog = optionPane.createDialog(mParent, mParent.getResourceBundle().getString("SlinkPass.dialog.title.result"));
        final String cmd = prepareCmd(path, id, pw);
        SwingWorker<String, String> swingWorker = new SwingWorker<String, String>() {
            String os = System.getProperty("os.name");
            Process process = null;
            BufferedReader bufferedReader = null;
            @Override
            protected String doInBackground() {
                String result = "";
                try {
                    if (os.startsWith("Windows")) {
                        process = Runtime.getRuntime().exec("cmd /c " + cmd, null);
                    }
                    else if (os.startsWith("Mac")) {
                        process = Runtime.getRuntime().exec(cmd, null);
                    }
                    else {
                        process = Runtime.getRuntime().exec(cmd, null);
                    }

                    bufferedReader = new BufferedReader(new InputStreamReader(process.getInputStream(), System.getProperty("sun.jnu.encoding")));
                    String line = bufferedReader.readLine();
                    while (line != null) {
                        if (!"".equals(line)) {
                            result += line + "\n";
                        }
                        // Publish intermediate stdout result
                        publish(result);
                        line = bufferedReader.readLine();
                    }

                    // Return final execution result
                    process.waitFor();
                    result = String.valueOf(process.exitValue());

                } catch (CancellationException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - Connect VPN canceled 1");
                } catch (IOException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Connect VPN failed 1", ex);
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Connect VPN failed 1", ex);
                } finally {
                    if (null != bufferedReader) {
                        try {
                            bufferedReader.close();
                        } catch (IOException ex) {
                             Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Close bufferedReader failed", ex);
                        }
                    }
                    if (null != process) {
                        process.destroy();
                    }
                }

                return result;
            }

            @Override
            public void process(List<String> chunks) {
                for (String str : chunks) {
                    optionPane.setMessage(str);
                    dialog.setContentPane(optionPane);
                    dialog.pack();
                    SeciossUtils.center(mParent, dialog);
                }
            }

            @Override
            public void done() {
                try {
                    String result = get(SlinkSwingWorker.TIMEOUT*30, TimeUnit.SECONDS);
                    if (os.startsWith("Mac")) {
                        optionPane.setMessage(mParent.getResourceBundle().getString("SlinkTabPanelVpn.dialog.started"));
                    }
                    if ("0".equals(result)) {
                        optionPane.setIcon(UIManager.getIcon("OptionPane.informationIcon"));
                    }
                    else {
                        optionPane.setIcon(UIManager.getIcon("OptionPane.warningIcon"));
                    }
                    optionPane.setOptions(mParent.getButtonsMessageDialog());
                    dialog.setContentPane(optionPane);
                    dialog.pack();
                    SeciossUtils.center(mParent, dialog);
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "Connect VPN result: {0}", result);
                } catch (CancellationException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - Connect VPN canceled 2");
                    if (null != process) {
                        process.destroy();
                    }
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Connect VPN failed 2", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Connect VPN failed 2", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "Connect VPN failed 2", ex);
                }
            }
        };
        swingWorker.execute();
        dialog.setVisible(true);
        if (null != optionPane.getValue() && mParent.getButtonsCancelDialog()[0].equals(optionPane.getValue())) {
            swingWorker.cancel(true);
        }
    }

    private String prepareCmd(String path, String id, String pw) {
        if (null == path || "".equals(path)) {
            return null;
        }
        // rasdial \"connection name\" %{id} %{pw}
        String cmd = path;
        // Replace username
        int sIndex = cmd.indexOf("%{id}");
        int eIndex = sIndex + 5;
        if (sIndex >= 0) {
            cmd = cmd.substring(0, sIndex) + id + cmd.substring(eIndex);
        }
        // Replace password
        sIndex = cmd.indexOf("%{pw}");
        eIndex = sIndex + 5;
        if (sIndex >= 0) {
            cmd = cmd.substring(0, sIndex) + pw + cmd.substring(eIndex);
        }
        Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.CONFIG, "DEBUG - Command: {0}", cmd);
        return cmd;
    }

}
