/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass;

import jp.co.secioss.lib.SeciossUtils;
import java.awt.HeadlessException;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URISyntaxException;
import java.net.URLEncoder;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.table.TableModel;
import jp.co.secioss.lib.MD5;
import jp.co.secioss.lib.SQLiteAdapter;
import jp.co.secioss.lib.SeciossCommon;
import jp.co.secioss.spass.components.SlinkPassTableCellEditorAndRenderer;
import jp.co.secioss.spass.components.SlinkPassTableModel;

/**
 *
 * @author shuu
 */
public class SlinkTabPanelWc extends SlinkTabPanelAbstract {
    private static final long serialVersionUID = 1L;

    private SlinkPass mParent;
    private SQLiteAdapter mSQLiteAdapter;
    private String[] mProxy;
    private String mScheme;
    private String mSecret;

    public SlinkTabPanelWc(SlinkPass parent) {
        super();
        this.mParent = parent;
        mSQLiteAdapter = parent.getSQLiteAdapter();

        mSecret = mParent.getConfigure().get(SlinkPass.PREF_KEY_DECODED);
        initTable();
        initNetwork();
        initSchemeAsync();
    }

    private void initTable() {
        List<Map<String, String>> list = mSQLiteAdapter.selectWebClient(null);
        int count = list.size();
        String rows[][] = new String[1][6];
        if (count > 0) {
            rows = new String[count + 1][6];
            for (int i = 0; i < count; i++) {
                Map<String, String> map = list.get(i);
                rows[i][0] = map.get(SQLiteAdapter.COL_WEBCLIENT_ID);
                rows[i][1] = map.get(SQLiteAdapter.COL_WEBCLIENT_NAME);
                rows[i][2] = map.get(SQLiteAdapter.COL_WEBCLIENT_PATH);
                rows[i][3] = map.get(SQLiteAdapter.COL_WEBCLIENT_PARAM);
                rows[i][4] = map.get(SQLiteAdapter.COL_COMMON_CREATE_TIME);
                rows[i][5] = map.get(SQLiteAdapter.COL_COMMON_UPDATE_TIME);
            }
        }

        String[] cols = new String[] {
                //SQLiteAdapter.COL_WEBCLIENT_ID,
                SQLiteAdapter.COL_WEBCLIENT_NAME,
                //SQLiteAdapter.COL_WEBCLIENT_PATH,
                //SQLiteAdapter.COL_WEBCLIENT_PARAM,
                //SQLiteAdapter.COL_COMMON_CREATE_TIME,
                //SQLiteAdapter.COL_COMMON_UPDATE_TIME,
                COL_TABLE_OPERATION
        };

        Class<?>[] typs = new Class<?>[] {String.class, JPanel.class};

        TableModel model = new SlinkPassTableModel(rows, cols, typs, (null != mSecret && !"".equals(mSecret)));
        getJTable1().setModel(model);
        getJTable1().getColumnModel().getColumn(cols.length-1).setPreferredWidth(0);

        getJTable1().getColumn(SQLiteAdapter.COL_WEBCLIENT_NAME).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(SQLiteAdapter.COL_WEBCLIENT_NAME).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellEditor(new SlinkPassTableCellEditorAndRenderer(this));
        getJTable1().getColumn(COL_TABLE_OPERATION).setCellRenderer(new SlinkPassTableCellEditorAndRenderer(this));
    }

    private void initNetwork() {
        String proxytpye = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_TYPE);
        String proxyhost = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_HOST);
        String proxyport = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PORT);
        String proxyuser = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_USER);
        String proxypass = mParent.getConfigure().get(SlinkPass.PREF_KEY_PROXY_PASS);
        mProxy = new String[] {proxytpye, proxyhost, proxyport, proxyuser, proxypass};
    }

    private void initSchemeAsync() {
        if (null == mSecret || "".equals(mSecret)) {
            return;
        }
        mScheme = mParent.getConfigure().get(SlinkPass.PREF_KEY_SCHEME);
        String server = SeciossUtils.URI_SCHEME + mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER) + SeciossUtils.URI_PATH_SCHEME;
        String userid = mParent.getConfigure().get(SlinkPass.PREF_KEY_USERID);
        String tenant = userid.substring(userid.indexOf("@") + 1);
        String device = mParent.getConfigure().get(SlinkPass.PREF_KEY_DEVICE);
        String username = new MD5(device).asHex() + "#" + userid;
        String os = System.getProperty("os.name");
        String params = "";
        try {
            params += "username=" + URLEncoder.encode(username, "UTF-8");
            params += "&tenant=" + URLEncoder.encode(tenant, "UTF-8");
            params += "&os=" + URLEncoder.encode(os, "UTF-8");
        }
        catch (UnsupportedEncodingException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "UnsupportedEncodingException", ex);
            return;
        }
        new SlinkSwingWorker(server, params, mProxy) {
            @Override
            public void done() {
                try {
                    // onSchemeResult
                    String response = get(TIMEOUT, TimeUnit.SECONDS);
                    String scheme = parseScheme(response);
                    if (!"".equals(scheme)) {
                        mScheme = scheme;
                    }
                } catch (InterruptedException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch scheme failed", ex);
                } catch (ExecutionException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch scheme failed", ex);
                } catch (TimeoutException ex) {
                    Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.SEVERE, "DEBUG - Fetch scheme failed", ex);
                }
            }
        }.execute();
    }

    private String parseScheme(String response) {
        String result = "";
        if (null == response) {
            return result;
        }
        int sIndex = response.indexOf("<code>");
        int eIndex = response.indexOf("</code>");
        String code = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex+6, eIndex) : "";
        if ("0".equals(code)) {
            sIndex = response.indexOf("<browser>");
            eIndex = response.indexOf("</browser>");
            result = (0 <= sIndex && sIndex < eIndex) ? response.substring(sIndex+9, eIndex) : "";
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.FINE, "DEBUG - Fetch scheme succeeded: [{0}]", result);
        }
        else {
            mParent.getLabelErrors().setText(mParent.getResourceBundle().getString("SlinkPass.mLabelErrors.scheme"));
        }
        return result;
    }

    @Override
    public void doEdit(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }

        final SlinkPassEditorWc slinkPassEditorWc = new SlinkPassEditorWc(mParent, data);
        SeciossUtils.center(mParent, slinkPassEditorWc);
        slinkPassEditorWc.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosed(WindowEvent e) {
                initTable();
            }
        });
        slinkPassEditorWc.setVisible(true);
    }

    @Override
    public void doDele(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }
        int i = JOptionPane.showOptionDialog(this, new JLabel(mParent.getResourceBundle().getString("SlinkTabPanelWc.dialog.confirm")), mParent.getResourceBundle().getString("SlinkPass.dialog.title.confirm"),
                        JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, UIManager.getIcon("OptionPane.questionIcon"), mParent.getButtonsConfirmDialog(), mParent.getButtonsConfirmDialog()[1]);
        if (i==0) {
            mSQLiteAdapter.deleteWebClient(data[0]);
            initTable();
        }
    }

    @Override
    public void doOpen(String[] data) {
        if (null == data || data.length != 6) {
            return;
        }
        String path = data[2];
        String uri = prepareUri(path);
        if (null == uri) {
            JOptionPane.showOptionDialog(this, new JLabel(mParent.getResourceBundle().getString("SlinkTabPanelWc.dialog.error.path")), mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                    JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
            return;
        }

        try {
            SeciossUtils.launchBrowser(mScheme, uri);
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "DEBUG - Launch browser succeeded: {0} {1}", new Object[]{mScheme, uri});
            return;
        } catch (HeadlessException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, "DEBUG - Launch browser failed: " + mScheme+uri, ex);
        } catch (IOException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, "DEBUG - Launch browser failed: " + mScheme+uri, ex);
        } catch (URISyntaxException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, "DEBUG - Launch browser failed: " + mScheme+uri, ex);
        }

        JOptionPane.showOptionDialog(this, new JLabel(mParent.getResourceBundle().getString("SlinkTabPanelWc.dialog.error")), mParent.getResourceBundle().getString("SlinkPass.dialog.title.error"),
                JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, UIManager.getIcon("OptionPane.errorIcon"), mParent.getButtonsMessageDialog(), mParent.getButtonsMessageDialog()[0]);
        System.out.println(uri);
    }

    private String prepareUri(String path) {
        String uri = null;
        if (SeciossCommon.checkUrl(SeciossUtils.URI_SCHEME + path) != 0) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.WARNING, "DEBUG - Invalid URL: {0}", path);
            return uri;
        }

        String server = mParent.getConfigure().get(SlinkPass.PREF_KEY_SERVER);
        String pinnum = mParent.getConfigure().get(SlinkPass.PREF_KEY_PINNUM);
        String device = mParent.getConfigure().get(SlinkPass.PREF_KEY_DEVICE);
        String userid = mParent.getConfigure().get(SlinkPass.PREF_KEY_USERID);
        String tenant = userid.substring(userid.indexOf("@") + 1);

        String username = new MD5(device).asHex() + "#" + userid;
        String password = SeciossCommon.generateOTP(mSecret, pinnum);
        String scheme = null == mScheme ? "" : mScheme;
        String bid = new MD5(password + mSecret + mScheme).asHex();
        String back = SeciossUtils.URI_SCHEME + path + (path.indexOf("?") > 0 ? "&" : "?") + "tenant=" + tenant;
        String version = mParent.getConfigure().get(SlinkPass.PREF_KEY_VERSION);
        String os = System.getProperty("os.name");

        try {
            username = URLEncoder.encode(username, "UTF-8");
            scheme = URLEncoder.encode(scheme, "UTF-8");
            back = URLEncoder.encode(back, "UTF-8");
            os = URLEncoder.encode(os, "UTF-8");
        }
        catch (UnsupportedEncodingException ex) {
            Logger.getLogger(SeciossUtils.LOG_LOGGERNAME).log(Level.INFO, "UnsupportedEncodingException", ex);
            return uri;
        }

        uri = SeciossUtils.URI_SCHEME + server + SeciossUtils.URI_PATH_SIGNON;
        uri += "?username=" + username;
        uri += "&password=" + password;
        uri += "&scheme="   + scheme;
        uri += "&bid="      + bid;
        uri += "&back="     + back;
        uri += "&version="  + version;
        uri += "&os="       + os;

        return uri;
    }

}
