/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package jp.co.secioss.spass.components;

import java.io.File;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author shuu
 */
public class SlinkPassFileFilter extends FileFilter {
    private String mDescriptions;
    final String OS;

    public SlinkPassFileFilter(String descriptions) {
        this.mDescriptions = descriptions;
        OS = System.getProperty("os.name");
    }

    @Override
    public boolean accept(File file) {
        if (file.isDirectory()) {
            return true;
        }
        if (OS.startsWith("Windows")) {
            return file.getName().toLowerCase().endsWith(".exe");
        }
        else if (OS.startsWith("Mac")) {
            return file.getName().toLowerCase().endsWith(".app");
        }
        else {
            return true;
        }
    }

    @Override
    public String getDescription() {
        if (OS.startsWith("Windows")) {
            return mDescriptions + "(*.exe)";
        }
        else if (OS.startsWith("Mac")) {
            return mDescriptions + "(*.app)";
        }
        else {
            return mDescriptions;
        }
    }

}

